=== dcmdata/docs/CMakeLists.txt ===
# declare installation files
install(FILES datadict.txt DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT doc)
