=== dcmnet/docs/CMakeLists.txt ===
# declare installation files
install(FILES asconfig.txt testing.txt DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT doc)
