=== dcmqrdb/etc/CMakeLists.txt ===
# declare installation files
install(FILES dcmqrscp.cfg DESTINATION "${CMAKE_INSTALL_FULL_SYSCONFDIR}" COMPONENT etc)
