=== dcmtls/docs/CMakeLists.txt ===
# declare installation files
install(FILES ciphers.txt randseed.txt DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT doc)
